package dev.peerat.parser.visitor;

import dev.peerat.parser.Token;

public abstract class Visitor<T>{
	
	public static Visitor<Token> allToken(){
		return new TokenVisitor(true);
	}
	
	public static Visitor<Token> token(){
		return new TokenVisitor(false);
	}
	
	public abstract boolean canVisit(Class<?> type); //TODO change "Class<?> type" into "Object element" ?
	
	public abstract boolean canPropagate();
	
	public abstract VisitorBag visit(T element);
	
}
